#include <iostream>
#include <cstdlib>
#include <cerrno>
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h>
#include <sys/socket.h>

#include "global.h"

using namespace std;

int main( int argc, char *const argv [] ) {

	// check and evaluate command-line argument
	if ( argc < 2 ) {
		cerr << "usage: " << argv[0] << " <transport-id>" << endl;
		return 1;
	}
	int transportID = strtol( argv[1], NULL, 10 );
	cout << "Looking up transport ID: " << transportID << endl;

	// find port number corresponding to transport id
	struct sockaddr_in local;
	memset( &local, 0, sizeof(local) );
	local.sin_family = AF_INET;
	local.sin_addr.s_addr = INADDR_ANY;
	unsigned short p = pmap_getport( &local, studentID, transportID, IPPROTO_TCP );

	// NOTE: The 'transportID' in reality is a version number. If you ask for
	//       a "version" number which is not available, the system replies
	//       with the highest "version" number that is registered.  You may
	//       want to implement checks to assure that you are connected to the
	//       correct name daemon, although we have no plans to specifically
	//       test for this.

	if ( p == 0 ) {
		cerr << clnt_spcreateerror("pmap_getport") << endl;
		return 1;
	} 

	cout << "Port: " << p << endl;

	return 0;
}
