#include "pmap.h"
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cerrno>
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h>

using namespace std;

static const int studentID = 4711;

extern "C"
void JNICALL Java_pmap_set(JNIEnv *, jclass, jlong versnum, jint port) {
	if ( pmap_set( studentID, versnum, IPPROTO_TCP, port ) == 0 ) {
		cerr << "pmap_set: " << strerror(errno) << endl;
		abort();
	}
}

extern "C"
void JNICALL Java_pmap_unset(JNIEnv *, jclass, jlong versnum) {
	if ( pmap_unset( studentID, versnum ) == 0 ) {
		cerr << "pmap_unset: " << strerror(errno) << endl;
		abort();
	}
}

extern "C"
jint JNICALL Java_pmap_getport(JNIEnv *, jclass, jlong versnum) {
	struct sockaddr_in local;
	memset( &local, 0, sizeof(local) );
	local.sin_family = AF_INET;
	local.sin_addr.s_addr = INADDR_ANY;
	int p = pmap_getport( &local, studentID, versnum, IPPROTO_TCP );
	if ( p == 0 ) {
		cerr << clnt_spcreateerror("pmap_getport") << endl;
		abort();
	}
	return p;
}
