import java.io.*;
import java.net.*;

public class server {
	public static void main( String[] args ) {
		try {
			if ( args.length != 1 ) {
				System.err.print( "usage: " );
				System.err.print( server.class.getName() );
				System.err.println( " <transport-id>" );
				System.exit(1);
			}
			long transportID = Integer.parseInt( args[0] );
			System.out.print( "Given transport ID: " );
			System.out.println( transportID );

			// create TCP socket, get port, register with port mapping service
			ServerSocket ss = new ServerSocket(0);
			int port = ss.getLocalPort();
			System.out.print( "Port: " );
			System.out.println( port );
			pmap.set( transportID, port );

			// wait for user to finish program by pressing ENTER
			System.out.println( "Use rpcinfo to see your registration" );
			System.out.println( "Press ENTER to finish program" );			
			System.in.read();

			// deregister from port mapping
			pmap.unset( transportID );

			// close socket
			ss.close();
		} catch (Exception ex) {
			System.err.println(ex);
			ex.printStackTrace();
		}
	}
}
